#ifndef __ALGORITHMAN_MORSETREE_H
    #define __ALGORITHMAN_MORSETREE_H

    #include<string>
    #include<map>
    
    namespace AlgorithMan
    {
    
        class MorseTreeNode;
    
        class MorseTree
        {
            protected:
                MorseTreeNode* root;
                std::map<char, MorseTreeNode*> registered;
                std::string ToMorseCode(MorseTreeNode* n);
                void Insert(std::string code, char c);
            public:
                MorseTree();
                ~MorseTree();

                std::string ToMorseCode(std::string text);
                std::string FromMorseCode(std::string text);
        };
    
        class MorseTreeNode
        {
            friend class MorseTree;
            protected:
                char codepart; // . or - (in which direction am I under my parent?
                char content;
                MorseTreeNode* parent;
                MorseTreeNode* short_succ;
                MorseTreeNode* long_succ;
                MorseTreeNode(MorseTreeNode* parent, char codepart);
                ~MorseTreeNode();
        };
    }

#endif